<template>
  <div>
    <ul class="ulMenu">
      <menu class="returnMenu">
        <li class="liReturnMenu">
          <!-- <a href="#"> -->
          <a v-on:click="returnToHome()">
            <i><font-awesome-icon :icon="['fas', 'arrow-left']" size="1x"/></i><br>
            <span>Volver</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <!-- <a href="#"> -->
          <a v-on:click="connect()">
            <i><font-awesome-icon :icon="['fas', 'plug']" size="1x"/></i><br>
            <span>Conectar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="saveCode()">
            <i><font-awesome-icon :icon="['fas', 'save']" size="1x"/></i><br>
            <span>Guardar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="undo()">
            <i><font-awesome-icon :icon="['fas', 'undo']" size="1x"/></i><br>
            <span>&nbsp;&nbsp;&nbsp;Atrás&nbsp;&nbsp;&nbsp;</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="redo()">
            <i><font-awesome-icon :icon="['fas', 'redo']" size="1x"/></i><br>
            <span>Adelante</span>
          </a>
        </li>
      </menu>
      <!-- <menu class="listMenu"> -->
      <!--   <li> -->
      <!--     <!-1- <a href="#"> -1-> -->
      <!--     <a v-on:click="connect()"> -->
      <!--       <i><font-awesome-icon :icon="['fas', 'plug']" size="1x"/></i><br> -->
      <!--       <span>Conectar</span> -->
      <!--     </a> -->
      <!--   </li> -->
      <!--   <li> -->
      <!--     <a v-on:click="saveCode()"> -->
      <!--       <i><font-awesome-icon :icon="['fas', 'save']" size="1x"/></i><br> -->
      <!--       <span>Guardar</span> -->
      <!--     </a> -->
      <!--   </li> -->
      <!--   <li> -->
      <!--     <a v-on:click="undo()"> -->
      <!--       <i><font-awesome-icon :icon="['fas', 'undo']" size="1x"/></i><br> -->
      <!--       <span>&nbsp;&nbsp;&nbsp;Atrás&nbsp;&nbsp;&nbsp;</span> -->
      <!--     </a> -->
      <!--   </li> -->
      <!--   <li> -->
      <!--     <a v-on:click="redo()"> -->
      <!--       <i><font-awesome-icon :icon="['fas', 'redo']" size="1x"/></i><br> -->
      <!--       <span>Adelante</span> -->
      <!--     </a> -->
      <!--   </li> -->
      <!-- </menu> -->
    </ul>
  </div>
</template>

<script lang="ts">

/**
Código fuente original: Floating Circular Menu
Copyright (c) 2021 by Mojtaba Seyedi (https://codepen.io/seyedi/pen/IrDkc)

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit
persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/**
* Del anterior código fuente se ha inpirado para lograr los efectos de transición,
* los ajustes javascript son propios
* @author Johnny Cubides
*/
import { defineComponent, ref, onMounted } from 'vue'
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
import BlocklyLang from 'blockly/lua'
import Blockly from 'blockly'
import { library } from '@fortawesome/fontawesome-svg-core'
import { faArrowLeft, faPlug, faSave, faUndo, faRedo } from '@fortawesome/free-solid-svg-icons'

library.add(faArrowLeft, faPlug, faSave, faUndo, faRedo)
declare var Android: any // eslint-disable-line

export default defineComponent({
  components: {
    'font-awesome-icon': FontAwesomeIcon
  },

  props: ['parentWorkspace'],
  setup (props) {

    const returnToHome = (): void => {
      try {
        Android.returnToHome()
      } catch (Error) {
        console.log('Android.saveProject() failed', Error)
      }
    }

    const saveCode = (): void => {
      try {
        Android.saveProject(getCodeLua(), getXMLBlockly())
      } catch (Error) {
        console.log('Android.saveProject() failed', Error)
      }
    }

    const getXMLBlockly = (): string => {
      const xml = Blockly.Xml.workspaceToDom(props.parentWorkspace)
      return Blockly.Xml.domToText(xml)
    }

    const getCodeLua = (): string => {
      (BlocklyLang as any).INFINITE_LOOP_TRAP = null // eslint-disable-line
      return (BlocklyLang as any).workspaceToCode(props.parentWorkspace) // eslint-disable-line
    }

    const undo = (): void => {
      props.parentWorkspace.undo(false)
    }

    const redo = (): void => {
      props.parentWorkspace.undo(true)
    }

    const connect = (): void => {
      try {
        Android.startConnectActivity(getCodeLua(), getXMLBlockly()) // eslint-disable-line
      } catch (Error) {
        console.log('Android.connect() failed', Error)
      }
    }
    return {
      // Methods
      returnToHome,
      saveCode,
      getXMLBlockly,
      getCodeLua,
      undo,
      redo,
      connect
    }
  }
})
</script>

<style scoped>
div {
  /* TODO STYLE */
  background-color: #131516;
  /* background-image: url('https://images.unsplash.com/photo-1564500617448-e541b1df7cee?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80');*/
  /* background-image: url('../assets/FocusMenu/photo-1564500617448-e541b1df7cee.webp?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80');*/
  /* background: url(../assets/FocusMenu/banner_moon1.jpg); */
  background-size : cover;
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
}

.ulMenu {
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
  /* margin-left: -40px;*/
  width  : auto;
}

.liReturnMenu {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0) 85%, rgba(255,255,255,0) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.0);
  border-bottom : 2px solid rgba(50,50,50,0.0);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

.returnMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  left: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
}

.listMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  right: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
  /*height: 200px; tamaño menu*/
}

.listMenu:after , .listMenu:before {
  display : block;
  content : ' ';
}

.listMenu:after {
  clear : both;
}

li {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0.1) 85%, rgba(255,255,255,0.5) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.5);
  border-bottom : 2px solid rgba(50,50,50,0.4);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

li:first-child {
  border-radius : 5px 0 0 5px;
}

li:last-child {
  border-radius : 0 5px 5px 0;
}

i {
  padding: 0px 0px;
  margin: 0px 0px 0px 0px;
}

a {
  display : block;
  text-align: center;
  line-height: 0.5;
  padding : 8px 8px; /* 10px 13px */
  font-size : 20px;   /* 26px */
  text-decoration : none;
  border-radius   : 20px;
  position        : relative;
  top   : 0;
  color : #FFF;
  transition : all .4s;
  z-index: 71;
}

span {
  display: inline-block;
  font-size: 12px;
  pointer-events: none;
  padding : 0px 0px;
  margin: 0px 0px 0px 0px;
}

/*li:hover a {*/
li:active a {
  /* TODO STYLE */
  top   : -5px; /* - arriba + abajo Desplazamiento al poner el cursor sobre el boton */
  color : black; /* color to convert skyBlue #4eacff*/
  background-color: #fff;
  box-shadow : 0 0 5px 0 rgba(255, 255, 255, 0.7);
  transition : all .1s;
  border-color : dark;
}

li a:after {
  display  : block;
  content  : '';
  position : relative;
  top  : 100%;
  left : 0%;
  border-style : solid;
  border-color : transparent;
  border-width : 5px 5px 0 5px;
  transition   : all .4s;
}

/*li:hover a:after {*/
li:active a:after {
  border-color : white transparent transparent transparent;
  transition   : all 0.7s;
}
</style>
